unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, LZSS, StdCtrls, shellapi, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Offset: TEdit;
    EndAddress: TEdit;
    SpeedButton1: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  InFile, OutFile: TFileStream;
  InBuffer, OutBuffer: array of Byte;
  InSize, OutSize: LongWord;
  LZ: TLZ;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenread);
    InSize:= InFile.Size;
    SetLength(InBuffer, InSize);
    SetLength(OutBuffer, InSize);
    InFile.ReadBuffer(InBuffer[0], Length(InBuffer));
    InFile.Free;
    LZ:= TLZ.Create;
    OutSize:= LZ.Compress(InBuffer[0], OutBuffer[0], InSize);
    if SaveDialog1.Execute() then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      OutFile.WriteBuffer(OutBuffer[0], OutSize);
      OutFile.Free;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute() then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenread);
    InFile.Position:= StrToInt(Offset.Text);
    if (InFile.Size - InFile.Position) > $FFFF then
      InSize:= $FFFF
    else
      InSize:= InFile.Size - InFile.Position;
    SetLength(InBuffer, InSize);
    SetLength(OutBuffer, $FFFF);
    InFile.ReadBuffer(InBuffer[0], Length(InBuffer));
    InFile.Free;
    LZ:= TLZ.Create;
    OutSize:= LZ.DeCompress(InBuffer[0], OutBuffer[0]);
    EndAddress.Text:='$' + IntToStr(StrToInt(Offset.Text) + (OutBuffer[OutSize] shl 8) + OutBuffer[OutSize+1]);
    if SaveDialog1.Execute() then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      OutFile.WriteBuffer(OutBuffer[0], OutSize);
      OutFile.Free;
    end;
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  shellexecute(0, 'open', 'www.chief-net.ru',nil, nil, sw_show);
end;

end.
